Index: /code/branches/gamestate/data/gui/scripts/AudioMenu.lua
===================================================================
--- /code/branches/gamestate/data/gui/scripts/AudioMenu.lua	(revision 6658)
+++ /code/branches/gamestate/data/gui/scripts/AudioMenu.lua	(revision 6659)
@@ -3,5 +3,5 @@
 local P = createSheet("AudioMenu")
 
-function P:init()
+function P.init()
     soundMgr = orxonox.SoundManager:getInstance()
     block = false
Index: /code/branches/gamestate/data/gui/scripts/GameplayMenu.lua
===================================================================
--- /code/branches/gamestate/data/gui/scripts/GameplayMenu.lua	(revision 6658)
+++ /code/branches/gamestate/data/gui/scripts/GameplayMenu.lua	(revision 6659)
@@ -3,5 +3,5 @@
 local P = createSheet("GameplayMenu")
 
-function P:init()
+function P.init()
     dropdown = winMgr:getWindow("orxonox/ThemeCombobox")
     local themeList = {}
Index: /code/branches/gamestate/data/gui/scripts/GraphicsMenu.lua
===================================================================
--- /code/branches/gamestate/data/gui/scripts/GraphicsMenu.lua	(revision 6658)
+++ /code/branches/gamestate/data/gui/scripts/GraphicsMenu.lua	(revision 6659)
@@ -3,5 +3,5 @@
 local P = createSheet("GraphicsMenu")
 
-function P:init()
+function P.init()
     block = true
     file = orxonox.PathConfig:getConfigPathString() .. orxonox.getConfig("GraphicsManager", "ogreConfigFile_")
Index: /code/branches/gamestate/data/gui/scripts/KeyBindMenu.lua
===================================================================
--- /code/branches/gamestate/data/gui/scripts/KeyBindMenu.lua	(revision 6658)
+++ /code/branches/gamestate/data/gui/scripts/KeyBindMenu.lua	(revision 6659)
@@ -3,5 +3,5 @@
 local P = createSheet("KeyBindMenu")
 
-function P:init()
+function P.init()
 
     commandList = {}
Index: /code/branches/gamestate/data/gui/scripts/MouseControlsMenu.lua
===================================================================
--- /code/branches/gamestate/data/gui/scripts/MouseControlsMenu.lua	(revision 6658)
+++ /code/branches/gamestate/data/gui/scripts/MouseControlsMenu.lua	(revision 6659)
@@ -3,5 +3,5 @@
 local P = createSheet("MouseControlsMenu")
 
-function P:init()
+function P.init()
     block = false
     mousenormalscrollbarwindow = tolua.cast(winMgr:getWindow("orxonox/MouseNormalScrollbar"),"CEGUI::Scrollbar")
Index: /code/branches/gamestate/data/gui/scripts/MultiplayerMenu.lua
===================================================================
--- /code/branches/gamestate/data/gui/scripts/MultiplayerMenu.lua	(revision 6658)
+++ /code/branches/gamestate/data/gui/scripts/MultiplayerMenu.lua	(revision 6659)
@@ -3,5 +3,5 @@
 local P = createSheet("MultiplayerMenu")
 
-function P:init()
+function P.init()
     listbox = winMgr:getWindow("orxonox/MultiplayerLevelListbox")
     preselect = orxonox.LevelManager:getInstance():getDefaultLevel()
Index: /code/branches/gamestate/data/gui/scripts/PickupInventory.lua
===================================================================
--- /code/branches/gamestate/data/gui/scripts/PickupInventory.lua	(revision 6658)
+++ /code/branches/gamestate/data/gui/scripts/PickupInventory.lua	(revision 6659)
@@ -8,10 +8,10 @@
 
 -- events
-function P:frmUpdate(e)
+function P.frmUpdate(e)
     local equipCount = orxonox.PickupInventory:getEquipmentCount()
     local usableCount = orxonox.PickupInventory:getUsableCount()
 
-    if equipCount ~= self.lastEquipmentCount_ or usableCount ~= self.lastUsableCount_ then
-        self:updateTabs()
+    if equipCount ~= P.lastEquipmentCount_ or usableCount ~= P.lastUsableCount_ then
+        P.updateTabs()
     end
 end
@@ -25,5 +25,5 @@
 end
 
-function P:mItemClicked(e)
+function P.mItemClicked(e)
     local w = CEGUI.toWindowEventArgs(e).window
     local name = w:getName()
@@ -36,9 +36,9 @@
 
     if t == "use" then
-        if self.currentUsableID_ >= 0 then
-            winMgr:getWindow("orxonox/Inventory/Title/use/" .. self.currentUsableID_):setProperty("TextColours", "tl:FFFFFFFF tr:FFFFFFFF bl:FFFFFFFF br:FFFFFFFF")
+        if P.currentUsableID_ >= 0 then
+            winMgr:getWindow("orxonox/Inventory/Title/use/" .. P.currentUsableID_):setProperty("TextColours", "tl:FFFFFFFF tr:FFFFFFFF bl:FFFFFFFF br:FFFFFFFF")
         end
         orxonox.PickupInventory:selectUsable(tonumber(i))
-        self.currentUsableID_ = tonumber(i)
+        P.currentUsableID_ = tonumber(i)
         winMgr:getWindow("orxonox/Inventory/Title/use/" .. i):setProperty("TextColours", "tl:FFFF4444 tr:FFFF4444 bl:FFFF4444 br:FFFF4444")
     end
@@ -46,5 +46,5 @@
 
 -- methods
-function P:updateTabs()
+function P.updateTabs()
     local eqWin = winMgr:getWindow("orxonox/Inventory/TabControl/TabEquipment")
     local usWin = winMgr:getWindow("orxonox/Inventory/TabControl/TabUsable")
@@ -52,7 +52,7 @@
     orxonox.PickupInventory:getSingleton():updateTabs(winMgr, eqWin, usWin)
 
-    self.currentUsableID_ = orxonox.PickupInventory:getCurrentUsableIndex()
-    self.lastEquipmentCount_ = orxonox.PickupInventory:getEquipmentCount()
-    self.lastUsableCount_ = orxonox.PickupInventory:getUsableCount()
+    P.currentUsableID_ = orxonox.PickupInventory:getCurrentUsableIndex()
+    P.lastEquipmentCount_ = orxonox.PickupInventory:getEquipmentCount()
+    P.lastUsableCount_ = orxonox.PickupInventory:getUsableCount()
 end
 
Index: /code/branches/gamestate/data/gui/scripts/QuestGUI.lua
===================================================================
--- /code/branches/gamestate/data/gui/scripts/QuestGUI.lua	(revision 6658)
+++ /code/branches/gamestate/data/gui/scripts/QuestGUI.lua	(revision 6659)
@@ -3,7 +3,7 @@
 local P = createSheet("QuestGUI")
 
-function P:show()
-    self.window:show() -- TDO: Do this through parent...
-    self.visible = true
+function P.show()
+    P.window:show() -- TDO: Do this through parent...
+    P.visible = true
 
     local questManager = orxonox.QuestManager:getInstance()
Index: /code/branches/gamestate/data/gui/scripts/SingleplayerMenu.lua
===================================================================
--- /code/branches/gamestate/data/gui/scripts/SingleplayerMenu.lua	(revision 6658)
+++ /code/branches/gamestate/data/gui/scripts/SingleplayerMenu.lua	(revision 6659)
@@ -3,5 +3,5 @@
 local P = createSheet("SingleplayerMenu")
 
-function P:init()
+function P.init()
     listbox = winMgr:getWindow("orxonox/SingleplayerLevelListbox")
     preselect = orxonox.LevelManager:getInstance():getDefaultLevel()